/*
 * This is the API for plugin to add effects to pcm datas
 *
 *
 * (* WORK IN PROGRESS *)
 *
*/
#ifndef __PLUG__EFFECT_H_
#define __PLUG__EFFECT_H_

#include "lamip.h"

typedef struct {
  struct _lamipPluginBase	common;
  int				(*probe)(lamipPCMInfo*, lamipPCMInfo*);
  int				(*filter)(void**, size_t*);
}				EffectPlugin;



#ifdef __cplusplus
extern "C" {
#endif

/* 
 * util_pcm.c
 *
 * some handy converters
 * use them if you are too lazy to do converting yourself
 * arguments are: buf, buf_len, data, data_len [, data_fmt]
 *
 * lamip_channel_mapper() converts X channels pcm to Y channels pcm
 * lamip_resampler() resample datas (TODO)
 * lamip_format_changer change format output like 16bits -> 24bits
*/

typedef size_t (*lamip_channel_mapper)(void*, const size_t,
				       const void*, const size_t,
				       const lamipPCMFormat);
typedef size_t (*lamip_resampler)(void*, const size_t,
				  const void*, const size_t,
				  const lamipPCMFormat);
typedef size_t (*lamip_format_changer)(void*, const size_t,
				       const void*, const size_t);

lamip_channel_mapper	lamip_pcm_getChannelMapper(const unsigned long, const unsigned long);
lamip_resampler		lamip_pcm_getResampler(const unsigned long, const unsigned long);
lamip_format_changer	lamip_pcm_getFormatChanger(const lamipPCMFormat, const lamipPCMFormat);

/*
 * decomposition pcm format to (samplesize, bigendian, sign)
*/
void	lamip_pcm_formatDecomp(lamipPCMFormat, unsigned int*, int*, int*);

/* 
 * convert data to signed 16-bit native encoding:
 * (fmt, data, left, right, nch, max)
 * max is maximum samples to convert
 */
void	lamip_pcm_to_s16ne(lamipPCMFormat, void*, void*, void*, unsigned int, int);

#ifdef __cplusplus
}
#endif


#endif /*  __PLUG__EFFECT_H_ */
