#ifndef __PLUG__OUT_H_
#define __PLUG__OUT_H_

#include <stdlib.h> /* for size_t */
#include "lamip.h"

typedef struct {
  char*		name;
  char*		description;
  int		(*init)(void);
  void		(*cleanup)(void);
  void		(*configuration)(lamipPluginHandle*);
  void		(*get_volume)(int*, int*);  // (left,right)
  void		(*set_volume)(int);
  int		(*open)(const lamipPCMInfo*);
  void		(*close)(void);
#ifdef NEWAPI
  size_t	(*write)(const void*, size_t); // (datas, size)
  void		(*drain)(void);
  void		(*drop)(void);
#else
  void		(*write)(void*, unsigned int); // (datas, size)
#endif
} OutputPlugin;

#ifdef __cplusplus
extern "C" {
#endif


#ifdef __cplusplus
}
#endif

#endif /*  __PLUG__OUT_H_ */
